# Příklad: vlastní datová struktura -- jednoduchý zřetězený seznam
# objekty typu Node jsou položky v seznamu
# (drží nějaká data a odkazují na další položku v seznamu)
# objekt typu List reprezentuje seznam
# (drží odkaz na první položku v seznamu)


class Node:
    def __init__(self, data):
        self.data = data
        self.next = None


class List:
    def __init__(self):
        self.first = None

    def insert_at_start(self, data):
        node = Node(data)
        node.next = self.first
        self.first = node

    def delete_first(self):
        if self.first != None:
            self.first = self.first.next

    def output(self):
        node = self.first
        while node != None:
            print(node.data)
            node = node.next

# zkuste si:
# s = List()
# s.insert_at_start("Hello")
# s.insert_at_start("Ahoj")
# s.output()
# s.delete_first()
# s.output()
