# Příklad: studenti a předměty
# objekty typu Student představují studenty s UČem a jménem
# objekty typu Course představují předměty s kódem a seznamem studentů


class Student:
    def __init__(self, uco, name):
        self.uco = uco
        self.name = name


class Course:
    def __init__(self, code):
        self.code = code
        self.students = []

    def add_student(self, student):
        self.students.append(student)

    def print_students(self):
        i = 1
        for s in self.students:
            print(str(i) + ".", str(s.uco) + "\t" + s.name)
            i += 1


# takto vytváříme studenty
jimmy = Student(555007, "James Bond")

# takto vytváříme předměty
ib113 = Course("IB113")

# takto přidáváme studenty k předmětu
ib113.add_student(Student(555000, "Jan Novák"))
ib113.add_student(jimmy)
ib113.add_student(Student(555555, "Kryštof Harant"))

# zkuste si:

# ib113.print_students()
